package HotText::Command;

use Tk;

use base qw/Tk::Frame Tk::Text Tk::Entry Tk::Button Tk::Derived /;

Construct Tk::Widget 'Command';

use vars qw/ $win @wins /;
$win=0;

sub Populate {
    my ($self, $args) = @_;

	$wins[$win] = $self->Toplevel;

	my $cw = $wins[$win];
	$win++;
    
	$commands = delete $args->{"-commands"};
	if (defined $commands) {
	}
	$target = delete $args->{"-target"};
	if (defined $target) {
	}
	
    $cw -> SUPER::Populate ($args);

	#-------------  widget definition

	my ($frame1) = $cw->Component('Frame','text');
	my ($frame2) = $cw->Component('Frame','target');
	my ($frame3) = $cw->Component('Frame','buttons');

	my ($scrollbar_1) = $cw->Scrollbar (
		-orient => 'v',
	);
	my ($scrollbar_2) = $cw->Scrollbar (
		-orient => 'h',
	);
	my ($textbox) = $cw->Text (
		-height => '0',
		-width => '0',
		-wrap => 'none',
		-yscrollcommand => ['set' => $scrollbar_1],
		-xscrollcommand => ['set' => $scrollbar_2],
	);
	$scrollbar_1 ->configure(-command => ['yview' => $textbox],);
	$scrollbar_2 ->configure(-command => ['xview' => $textbox],);
	
	my ($entry) = $cw->Entry( -textvariable=>$target, -width=>50,);

	push @{$commands},['Clear',[\&clearbox, $textbox],];

	my %buttons;
	foreach my $but (@{$commands}) {
		($buttons{$but->[0]}) = $cw->Button(
									-text=>$but->[0],
									-anchor=>'n',
									-command=>sub{
										&{$but->[1]->[0]}('end',$textbox,@{$but->[1]});
									},
		                       );
	}
	my ($exit) = $cw->Button(
	                    -text => "Exit",
						-command => [\&exitbox, $cw],
	                 );

	#--------------- geometry definition
	
	$frame1->grid(
		-in=>$cw,
		-column=>2,
		-row=>2,
	);

	$frame2->grid(
		-in=>$cw,
		-column=>2,
		-row=>1,
	);

	$frame3->grid(
		-in=>$cw,
		-column=>1,
		-row=>1,
		-rowspan=>2,
		-sticky => 'n',
	);

	$entry->grid(
		-in=>$frame2,
		-column=>1,
		-row=>1,
		-sticky => 'w',
	);

	$textbox->grid(
		-in=>$frame1,
		-column=>1,
		-row=>1,
		-sticky => 'nsew'
	);
	$scrollbar_1->grid(
		-in => $frame1,
		-column => '2',
		-row => '1',
		-sticky => 'ns'
	);
	$scrollbar_2->grid(
		-in => $frame1,
		-column => '1',
		-row => '2',
		-sticky => 'ew'
	);

	#	Build buttons

	my $row;
	for (my $i=0;$i< @{$commands};$i++) {
		my $but = $commands->[$i]->[0];
		$row = $i+1;
		$buttons{$but} -> grid (
			-in => $frame3,
			-column => '1',
			-row => $row,
			-sticky => 'wn',
		);
	}
	$row++;
	$exit->grid (
		-in => $frame3,
		-column => 1,
		-row => $row,
		-sticky => 'wn',
	);

	$cw->gridRowconfigure(1, -weight => 0, -minsize => 30 );
	$cw->gridRowconfigure(2, -weight => 0, -minsize => 400 );

	$cw->gridColumnconfigure(1, -weight => 0, -minsize => 30 );
	$cw->gridColumnconfigure(2, -weight => 0, -minsize => 400 );

	$frame1->gridRowconfigure(1, -weight => 0, -minsize => 370 );
	$frame1->gridRowconfigure(2, -weight => 0, -minsize => 30 );

	$frame1->gridColumnconfigure(1, -weight => 0, -minsize => 370 );
	$frame1->gridColumnconfigure(2, -weight => 0, -minsize => 30 );

	$frame2->gridRowconfigure(1, -weight => 0, -minsize => 30 );
	$frame2->gridColumnconfigure(1, -weight => 0, -minsize => 400 );

	$frame3->gridRowconfigure(1, -weight => 0, -minsize => 30 );
	$frame3->gridColumnconfigure(1, -weight => 0, -minsize => 30 );

#---------------------
    #$cw -> Advertise   (Text  =>  $textbox);
    #$cw -> Delegates   (DEFAULT =>  $textbox);
    #$cw -> ConfigSpecs (-info   => [PASSIVE => "", "", undef],
    #                      DEFAULT => [$textbox]);

#---------------------

}

sub clearbox {
	my $self=shift;
	my $textbox=shift;
	$textbox -> delete('1.0','end');
}

sub exitbox {
	my $cw=shift;
	$cw->destroy;
}

1;
