package HotText::HotText;

use strict;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK);

require Exporter;

@ISA = qw(Exporter AutoLoader);
# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.
@EXPORT = qw(
	
);
$VERSION = '0.01';

sub new {
	my $proto = shift;
	my $class = ref($proto) || $proto; # use as object or class
	my $self = {};

	$self->{MW} = shift; # root window
	$self->{TAGS} = {}; # array of tagged data
			# {tag_type}[line number, beg char, end char, value]

	bless ($self, $class);
	return $self;
}

sub define_tags {
	my $self = shift;
	my $textbox = shift;
	my $tagdefs = shift;
	$self->{tagdefs} = $tagdefs;

	foreach (@{$tagdefs}) {
		$textbox->tagConfigure( $_->[0],
	                        -foreground =>$_->[1],
					);
		$textbox->tagBind( $_->[0],
	                   "<Button-1>",
					   [$_->[3]],
					);
	}

}

sub loadtext {
	my $self = shift;
	my $textbox = shift;
	my $text = shift;
	my $tagdefs = $self->{tagdefs} ;

	my $line = 1;
	foreach (@{$text}) {
		$textbox -> insert("end", $_) if defined $_;
#print STDERR $_;
		foreach my $tagdef (@{$tagdefs}) {
			my ($tags, $vals) = &{$tagdef->[2]}($_); # apply filter
			if ($tags && grep /$tagdef->[0]/,@{$tags}) {
				my $beg = 0;
				my $end = 0;
				foreach my $val (@{$vals}) {
					$beg = index($_, $val, $end);
					$end = $beg + length($val);
					$textbox->tagAdd($tagdef->[0],"$line.$beg", "$line.$end");
					push @{$self->{TAGS}{$tagdef->[0]}},[$line,$beg,$end,$val];
				}
			}
		}
		$line++;
	}
}

sub tagadd {
	my $self = shift;
	my $tagtype = shift;
	my ($beg,$end,$val) = @_;
	my $line;
	($line,$beg) = split(/\./,$beg);
	$end =~ s/^\d+\.//;
	push @{$self->{TAGS}{$tagtype}},[$line,$beg,$end,$val];
}

sub gettext { # retrieve it all
	my $self = shift;
	my $textbox = shift;
	my $text = $textbox->get('1.0','end');
	return $text;
}

sub getval {
	my $self =shift;
	my $textbox=shift;
	my $tag=shift;
	my $index = $textbox->index('current');
	my ($line,$char) = split(/\./,$index);
	foreach (@{$self->{TAGS}{$tag}}) {
		if ($line == $_->[0] && $char >= $_->[1] && $char <= $_->[2]) {
			return $_->[3];
		}
	}
}


1;
__END__
# Below is the stub of documentation for your module. You better edit it!

=head1 NAME

HotText - Perl extension for blah blah blah

=head1 SYNOPSIS

  use HotText;
  blah blah blah

=head1 DESCRIPTION

Stub documentation for HotText was created by h2xs. It looks like the
author of the extension was negligent enough to leave the stub
unedited.

Blah blah blah.

=head1 AUTHOR

A. U. Thor, a.u.thor@a.galaxy.far.far.away

=head1 SEE ALSO

perl(1).

=cut
